/* -*- c++ -*- */
#include <winsock2.h>
#include <winbase.h>
#include <winuser.h>

#include "escape.h"
#include "charcode.h"
#include "code.h"

#define TNT_VERSION "tnt version 1.06"
#define COPY_LEFT "programed by Applause"
#define BUILD_DATE __DATE__

#define FOREGROUND_WHITE (FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE)
#define EITHER_CTRL_PRESSED (LEFT_CTRL_PRESSED | RIGHT_CTRL_PRESSED)
#define EITHER_ALT_PRESSED (LEFT_ALT_PRESSED | RIGHT_ALT_PRESSED)

#ifdef DEBUG
#define PRINTF printf
#else
#define PRINTF 0 &&
#endif

void checkWindowSize(void);
unsigned char recvchar(SOCKET);
void sendchar(unsigned char);
void convertandsendkey(unsigned char,unsigned char,DWORD);
void sendflash(void);
int open_debug_socket(void);
void printerror(char *,DWORD);

HANDLE hstdin;
INPUT_RECORD InputRecord;
//CONSOLE_SCREEN_BUFFER_INFO buffer_info,buffer_info_back;
SMALL_RECT srWindow_back={-1,0,0,0};
SOCKET telnetsocket,debugsocket;
SOCKADDR_IN debug_addr;

#define RECVBUF_SIZE 4096
unsigned char recvbuf[RECVBUF_SIZE];
int recvbytes=0;
int recvindex=0;
#define SENDBUF_SIZE 4096
unsigned char sendbuf[SENDBUF_SIZE];
int sendbytes=0;
int sendindex=0;
int SJIS1=0;


void sendWill(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfb; //will
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}

void sendWont(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfc; //won't
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}

void sendDo(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfd; // DO
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}

void sendDont(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfe; // DON'T
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}


void main(int argc,char *argv[]){
    WSADATA wsadata;
    HOSTENT FAR * lphost_entry;
    SERVENT FAR * lpserv_entry;
    SOCKADDR_IN inet_addr;
    IN_ADDR in_addr;
    fd_set fdsetread,fdsetwrite,fdseterror;
    TIMEVAL TimeVal={0,10000};
    char hostname[256];
    u_short portnumber;
    unsigned char buf[256];
    int i,err,flag_ip_name;
    int numbytes,numread,numwritten;
    unsigned char charcode,keycode;
    DWORD controlkeystate;

    hstdout=GetStdHandle(STD_OUTPUT_HANDLE);
    hstdin=GetStdHandle(STD_INPUT_HANDLE);
    hscreen=hstdout;

    GetConsoleScreenBufferInfo(hstdout,&buffer_info);
    haltscreen=CreateConsoleScreenBuffer(
					 GENERIC_READ|GENERIC_WRITE,
					 0,
					 NULL,
					 CONSOLE_TEXTMODE_BUFFER,
					 NULL);
    if(haltscreen==INVALID_HANDLE_VALUE){
	printerror("CreateConsoleScreenBuffer",GetLastError());
    }
    SetConsoleMode(hstdin,ENABLE_WINDOW_INPUT);
    if(argc>=2){
	strcpy(hostname,argv[1]);
    }else{
	printf(TNT_VERSION "  " COPY_LEFT "  %s %s\n\n",Build_Date,Build_Time);
	printf("%s hostname port\n",argv[0]);
	exit(1);
/*
	printf("telnet>");
	strcpy(hostname,"eriko");
*/
    }

    escinit();

    WSAStartup(0x101,&wsadata);

    if(argc>=3){
	portnumber=atoi(argv[2]);
	if(portnumber==0){
	    lpserv_entry=getservbyname(argv[2],NULL);
	    if(lpserv_entry==NULL){
		printf("Wrong PortName : %s.\n",argv[2]);
		printerror("Error0",WSAGetLastError());
		exit(2);
	    }
	    portnumber=ntohs(lpserv_entry->s_port);
	}
    }else{
	portnumber=23;
    }
    telnetsocket=socket(AF_INET,SOCK_STREAM,PF_UNSPEC);
    if(telnetsocket==INVALID_SOCKET){
	printerror("Error1",WSAGetLastError());
	exit(3);
    }
    err=sscanf(hostname,"%d.%d.%d.%d",
	       &in_addr.s_net,
	       &in_addr.s_host,
	       &in_addr.s_lh,
	       &in_addr.s_impno);
    if(err==4){
	flag_ip_name=1;
	lphost_entry=gethostbyaddr((char *)&in_addr,sizeof(in_addr),AF_INET);
    }else{
	flag_ip_name=0;
	lphost_entry=gethostbyname(hostname);
    }
    if(lphost_entry==NULL && !flag_ip_name){
	err=WSAGetLastError();
	printerror("Error2",err);
	exit(4);
    }

    if(lphost_entry!=NULL){
	flag_ip_name=0;
    }
//    printf("CNAME=%s\n",lphost_entry->h_name);

    if(!flag_ip_name){
	inet_addr.sin_family=AF_INET;
	inet_addr.sin_port=htons(portnumber);
	inet_addr.sin_addr.S_un.S_addr=*(u_long *)*lphost_entry->h_addr_list;
    }else{
	inet_addr.sin_family=AF_INET;
	inet_addr.sin_port=htons(portnumber);
	inet_addr.sin_addr.S_un.S_addr=*(u_long *)&in_addr;
    }

    printf("Trying %d.%d.%d.%d...\n",
	   inet_addr.sin_addr.S_un.S_un_b.s_b1,
	   inet_addr.sin_addr.S_un.S_un_b.s_b2,
	   inet_addr.sin_addr.S_un.S_un_b.s_b3,
	   inet_addr.sin_addr.S_un.S_un_b.s_b4);

    err=connect(telnetsocket,(SOCKADDR FAR *)&inet_addr,sizeof(inet_addr));
    if(err==SOCKET_ERROR){
	printerror("Error3",WSAGetLastError());
	exit(5);
    }else{
	if(!flag_ip_name){
	    printf("Connected to %s.\n\n",lphost_entry->h_name);
	}else{
	    printf("Connected\n\n");
	}
    }

#if DEBUG
    if(open_debug_socket()!=0){
	printf("Error in open_debug_socket()!\n");
    }
#endif

    /*TimeVal.tv_sec=1;
      TimeVal.tv_usec=50000;
      printf("TimeVal.tv_sec=%ld\n",TimeVal.tv_sec);
      printf("TimeVal.tv_usec=%ld\n",TimeVal.tv_usec);
      */
    FD_ZERO(&fdsetwrite);
    FD_ZERO(&fdseterror);
    
    if(portnumber==23){
	buf[0]=0xff;        //IAC
	buf[1]=0xfb;        //WILL
	buf[2]=31;          //NAWS (Window Size)
	send(telnetsocket,buf,3,0);
    }

    while(1){
	unsigned char c;
	FD_ZERO(&fdsetread);
	FD_SET(telnetsocket,&fdsetread);

	    //		printf("test");
	    //			if(_kbhit()!=0){
	    //				buf[0]=_getch();
	{
	    PeekConsoleInput(hstdin,&InputRecord,1,&numread);
//	    GetNumberOfConsoleInputEvents(hstdin,&numread);
	    if(numread!=0){
		ReadConsoleInput(hstdin,&InputRecord,1,&numread);
		switch(InputRecord.EventType){
		case KEY_EVENT:
		    if(InputRecord.Event.KeyEvent.bKeyDown){
			charcode=(unsigned char)InputRecord.Event.KeyEvent.uChar.AsciiChar;
			keycode=InputRecord.Event.KeyEvent.wVirtualKeyCode;
			controlkeystate=InputRecord.Event.KeyEvent.dwControlKeyState;
			convertandsendkey(charcode,keycode,controlkeystate);

		    }else if(InputRecord.Event.KeyEvent.wVirtualKeyCode==VK_MENU){
			charcode=(unsigned char)InputRecord.Event.KeyEvent.uChar.AsciiChar;
			keycode=InputRecord.Event.KeyEvent.wVirtualKeyCode;
			controlkeystate=InputRecord.Event.KeyEvent.dwControlKeyState;
			convertandsendkey(charcode,keycode,controlkeystate);
			
		    }
		    break;
		case WINDOW_BUFFER_SIZE_EVENT:
		    checkWindowSize();
		    break;
		}
		continue;
	    }
	    sendflash();
	}
	if(recvbytes==0){
	    if((err=select(0,&fdsetread,&fdsetwrite,&fdseterror,&TimeVal))==0){
		escOutputFlush();
		checkWindowSize();
		continue;
	    }
	    if(err==SOCKET_ERROR){
		printerror("Error4",WSAGetLastError());
		exit(6);
	    }
	}
	c=recvchar(telnetsocket);
	if(c==0xff){
	    PRINTF("FF,"); //IAC
	    c=recvchar(telnetsocket);
	    PRINTF("%02X,",c);
	    if(c==0xfe){         //DON'T
		c=recvchar(telnetsocket);
		PRINTF("%02X\n",c);
	    }else if(c==0xfd){   //DO
		c=recvchar(telnetsocket);
		PRINTF("%02X\n",c);
		switch(c){
		case 24:                //TERMINAL-TYPE
		    buf[0]=0xff;	//IAC
		    buf[1]=0xfb;	//WILL
		    buf[2]=24;		//TERMINAL-TYPE
		    send(telnetsocket,buf,3,0);
		    buf[0]=0xff;	//IAC
		    buf[1]=0xfa;	//SB
		    buf[2]=24;		//TERMINAL-TYPE
		    buf[3]=0;		//IS
#if 0
		    buf[4]='v';
		    buf[5]='t';
		    buf[6]='1';
		    buf[7]='0';
		    buf[8]='0';
#else
		    buf[4]='k';
		    buf[5]='t';
		    buf[6]='e';
		    buf[7]='r';
		    buf[8]='m';
#endif
		    buf[9]=0xff;	//IAC
		    buf[10]=0xf0;	//SE
		    send(telnetsocket,buf,11,0);
		    break;
		case 31:                //NAWS (Window Size)
		    srWindow_back.Left=0;
		    //		    sendWill(c);
		    checkWindowSize();
		    break;
		    /*
		case 32: // 0x20 ?
		case 33: // 0x21 ?
		case 34: // 0x22 ?
		case 35: // 0x23 ?
		case 36: // 0x24 ?
		case 37: // 0x25 ?
		case 39: // 0x27 ?
		    break;
		    */
		default:
		    sendWont(c);
		    //		    sendWill(c);
		    break;
		}
	    }else if(c==0xfa){ //SB
		i=0;
		do{
		    c=recvchar(telnetsocket);
		    PRINTF("%02X,",c);
		    if(c==0xff && i==0)i=1;
		    else if(c==0xf0 && i==1)i=2;
		    else i=0;
		}while(i!=2);
		PRINTF("\n");
	    }else if(c==0xfb){	//WILL	
		c=recvchar(telnetsocket);
		PRINTF("%02X\n",c);
		switch(c){
		default:
		    sendDo(c);
		}
	    }
	}else{
	    escout(c);
	}
    }
}



unsigned char recvchar(SOCKET s){
    static unsigned char c;
    static int err;
	
    if(recvbytes==0){
	recvbytes=recv(telnetsocket,recvbuf,RECVBUF_SIZE,0);
	if(recvbytes==0){
	    printf("Connection Closed!\n");
#if DEBUG
	    closesocket(debugsocket);
#endif
	    exit(7);
	}else if(recvbytes==SOCKET_ERROR){
	    printerror("Error5",WSAGetLastError());
	    exit(8);
	}
	recvindex=0;
    }

    recvbytes--;
    c=recvbuf[recvindex++];
#if DEBUG
    send(debugsocket,&c,1,0);
#endif
    return c;
}

void sendflash(){
    int i;
    i=0;
    while(i!=sendbytes){
	i+=send(telnetsocket,&sendbuf[i],sendbytes-i,0);
    }
    sendindex=0;
    sendbytes=0;
}

void sendchar(unsigned char c){
    sendbuf[sendindex++]=c;
    sendbytes++;
    if(sendbytes==SENDBUF_SIZE){
	sendflash();
    }
}


// DEBUG ́Alocalhost ̃|[g24Ńj^p̃vO𓮂ĎgB
#if DEBUG
int open_debug_socket(void){
    int err;
    debugsocket=socket(AF_INET,SOCK_STREAM,PF_UNSPEC);
    if(debugsocket==INVALID_SOCKET){
	printf("DebugError1=%d\n",WSAGetLastError());
	return -1;
    }
    debug_addr.sin_family=AF_INET;
    debug_addr.sin_port=htons(24);
    debug_addr.sin_addr.S_un.S_addr=htonl(INADDR_LOOPBACK);
    err=connect(debugsocket,(SOCKADDR FAR *)&debug_addr,sizeof(debug_addr));
    if(err==SOCKET_ERROR){
	printf("DebugError2=%d\n",WSAGetLastError());
	debugsocket=INVALID_SOCKET;
	return -1;
    }
}
#endif

void convertandsendkey(unsigned char charcode,unsigned char keycode,
		  DWORD controlkeystate){
    if((keycode==VK_BACK || keycode==VK_F12) && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	closesocket(telnetsocket);
#if DEBUG
	if(debugsocket!=INVALID_SOCKET)
	    closesocket(debugsocket);
#endif
	printf("User Exit\n");
	exit(0);
    }
    if(keycode==VK_F1 && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	escSetKanjiMode(KM_EUC);
	INPUT_KANJI_MODE=KM_EUC;
	return;
    }
    if(keycode==VK_F2 && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	escSetKanjiMode(KM_SJIS);
	INPUT_KANJI_MODE=KM_SJIS;
	return;
    }
    if(keycode==VK_F3 && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	INPUT_KANJI_MODE=KM_ISO;
	return;
    }

    switch(INPUT_KANJI_MODE){
    case KM_SJIS:
	break;
    case KM_EUC:
	if(SJIS1!=0){
	    unsigned int kanjicode;
	    kanjicode=sjistojis((SJIS1<<8)|charcode);
	    sendchar((unsigned char)((kanjicode >>8)|0x80));
	    sendchar((unsigned char)((kanjicode & 0xff)|0x80));
	    SJIS1=0;
	    return;
	}else if(issjis1(charcode)){
	    SJIS1=charcode;
	    return;
	}else if(iskata(charcode)){
	    sendchar(0x8e);
	    sendchar(charcode);
	    return;
	}
	break;
    case KM_ISO:
	if(SJIS1!=0){
	    unsigned int kanjicode;
	    kanjicode=sjistojis((SJIS1<<8)|charcode);
	    sendchar(0x1b);
	    sendchar('$');
	    sendchar('B');
	    sendchar((unsigned char)(kanjicode >>8));
	    sendchar((unsigned char)(kanjicode & 0xff));
	    sendchar(0x1b);
	    sendchar('(');
	    sendchar('B');
	    SJIS1=0;
	    return;
	}else if(issjis1(charcode)){
	    SJIS1=charcode;
	    return;
	}else if(iskata(charcode)){
	    sendchar(0x1b);
	    sendchar('(');
	    sendchar('I');
	    sendchar((unsigned char)(charcode-0x80));
	    sendchar(0x1b);
	    sendchar('(');
	    sendchar('B');
	    return;
	}
	break;
    }

    switch(keycode){
//    case VK_BACK:
//	sendchar(0x7f);
//	break;
    case VK_SPACE:
	if(InputRecord.Event.KeyEvent.dwControlKeyState & EITHER_CTRL_PRESSED){
	    sendchar(0);
	}else{
	    sendchar(charcode);
	}
	break;
    case VK_RETURN:
	sendchar(0xd);
	sendchar(0);
	break;
    default:
	if(charcode!=0){
	    if((controlkeystate & EITHER_ALT_PRESSED)!=0){
		sendchar(ESC);
		sendchar(charcode);
	    }else{
		sendchar(charcode);
	    }
	}else{
	    escSendSpecialKey(telnetsocket,keycode,controlkeystate);
	}
    }
}

void checkWindowSize(void){
    unsigned char buf[16];
    if(srWindow_back.Left==-1)return;
    GetConsoleScreenBufferInfo(hstdout,&buffer_info);
//    if((buffer_info.dwSize.X!=dwSize_back.X)
//       || (buffer_info.dwSize.Y!=dwSize_back.Y)){
    if(buffer_info.srWindow.Top!=srWindow_back.Top ||
       buffer_info.srWindow.Bottom!=srWindow_back.Bottom){
//	Beep(440,100);
	buf[0]=0xff;        //IAC
	buf[1]=0xfa;        //SB
	buf[2]=31;          //NAWS (Window Size)
	buf[3]=buffer_info.dwSize.X >>8;
	buf[4]=buffer_info.dwSize.X & 0xff;
	{
	    int height;
	    height=buffer_info.srWindow.Bottom
	      -buffer_info.srWindow.Top+1-1;
	    buf[5]=height>>8;
	    buf[6]=height & 0xff;
	}
	buf[7]=0xff;        //IAC
	buf[8]=0xf0;        //SE
	send(telnetsocket,buf,9,0);
    }
    srWindow_back=buffer_info.srWindow;
}

void printerror(char *errstr,DWORD err){
    printf("%s : ",errstr);
    switch(err){
    case WSAECONNREFUSED:
	printf("ConnectionRefused!\n");
	break;
    case WSAECONNRESET:
	printf("ConnectionReset!\n");
	break;
    case WSAETIMEDOUT:
	printf("Timed Out!\n");
	break;
    case WSAHOST_NOT_FOUND:
	printf("Cannot Resolve the Name\n");
	break;
    case WSATRY_AGAIN:
	printf("WSATRY_AGAIN\n");
	break;
    case WSANO_RECOVERY:
	printf("WSANO_RECOVERY\n");
	break;
    case WSANO_DATA: //==WSANO_ADDRESS
	printf("WSANO_DATA or WSANO_ADDRESS\n");
	break;
    default:
	printf("ErrorCode=%08X(%d)\n",errstr,err);
    }
    return;
}

